import re
import os
import time
import requests
# from bs4 import BeautifulSoup
import BeautifulSoup
from selenium import webdriver

def ClaI_enzyme(DNAsequence):
	# Find all ATCGAT sequence in the DNAsequence
	found = [m.start() for m in re.finditer('ATCGAT', DNAsequence)]
	BigBag = []
	if (len(found) != 0):
		# Append the first term into the BigBag array
		start = 0
		end = found[0] + 2
		sequence = DNAsequence[start : end]
		BigBag.append(sequence)
		# Cutting the sequence
		for i in range(1,len(found)):
			start = end
			end = found[i] + 2
			# Cut the sequence on AT^CGAT
			sequence = DNAsequence[start : end]
			BigBag.append(sequence)
		
		start = found[len(found)-1] + 2
		BigBag.append(DNAsequence[start : ])
	else:
		BigBag.append(DNAsequence)
	return BigBag
	
def EcoRI_enzyme(DNAsequence):
	# Find all GAATTC sequence in the DNAsequence
	found = [m.start() for m in re.finditer('GAATTC', DNAsequence)]
	BigBag = []
	if (len(found) != 0):
		start = 0
		end = found[0] + 1
		sequence = DNAsequence[start : end]
		BigBag.append(sequence)
		# Cutting the sequence
		for i in range(1,len(found)):
			start = end
			end = found[i] + 1
			# Cut the sequence on G^AATTC
			sequence = DNAsequence[start : end]
			BigBag.append(sequence)

		start = found[len(found)-1] + 1
		BigBag.append(DNAsequence[start : ])
	else:
		BigBag.append(DNAsequence)
	return BigBag

def BamHI_enzyme(DNAsequence):
	# Find all GGATCC sequence in the DNAsequence
	found = [m.start() for m in re.finditer('GGATCC', DNAsequence)]
	BigBag = []
	if (len(found) != 0):
		start = 0
		end = found[0] + 1
		sequence = DNAsequence[start : end]
		BigBag.append(sequence)
		# Cutting the sequence
		for i in range(1,len(found)):
			start = end
			end = found[i] + 1
			# Cut the sequence on G^GATCC
			sequence = DNAsequence[start : end]
			BigBag.append(sequence)
		
		start = found[len(found)-1] + 1
		BigBag.append(DNAsequence[start : ])
	else:
		BigBag.append(DNAsequence)
	
	return BigBag

def HindIII_enzyme(DNAsequence):
	# Find all AAGCTT sequence in the DNAsequence
	found = [m.start() for m in re.finditer('AAGCTT', DNAsequence)]
	BigBag = []
	if (len(found) != 0):
		start = 0
		end = found[0] + 1
		sequence = DNAsequence[start : end]
		BigBag.append(sequence)
		# Cutting the sequence
		for i in range(1,len(found)):
			start = end
			end = found[i] + 1
			# Cut the sequence on A^AGCTT
			sequence = DNAsequence[start : end]
			BigBag.append(sequence)
		
		start = found[len(found)-1] + 1
		BigBag.append(DNAsequence[start : ])
	else:
		BigBag.append(DNAsequence)
	return BigBag

def PstI_enzyme(DNAsequence):
	# Find all CTGAG sequence in the DNAsequence
	found = [m.start() for m in re.finditer('CTGAG', DNAsequence)]
	BigBag = []
	if (len(found) != 0):
		start = 0
		end = found[0] + 4
		sequence = DNAsequence[start : end]
		BigBag.append(sequence)
		# Cutting the sequence
		for i in range(1,len(found)):
			start = end
			end = found[i] + 4
			# Cut the sequence on CTGA^G
			sequence = DNAsequence[start : end]
			BigBag.append(sequence)
		
		start = found[len(found)-1] + 4
		BigBag.append(DNAsequence[start : ])
	else:
		BigBag.append(DNAsequence)
	return BigBag


def FileReader(inputFile):
	inputFile = open(inputFile, "r")
	content = inputFile.read()
	inputFile.close()
	return content

def BagMaker(ArrayOfSequences, bagsName):
	Bags = []
	for i in range(0,len(ArrayOfSequences)):
		# Put the result into a hashMap
		bagName = bagsName + str(i+1)
		bagContent = ArrayOfSequences[i]
		bag = {bagName : bagContent}
		Bags.append(bag)
	return Bags

def main():
	inputFile = "DNAsequenceTestCases-4.txt"
	DNAsequence = FileReader(inputFile)

	# print DNAsequence.upper()

	As = ClaI_enzyme(DNAsequence)
	Bs = BamHI_enzyme(DNAsequence)

	# Open the browser and go to the website
	# url = 'http://localhost:8080/GMA/index.jsp'
	url = 'http://csce.unl.edu:8080/GMA/'
	browser = webdriver.Firefox()
	browser.set_window_size(1280,800)
	browser.get(url)
	browser.find_element_by_css_selector('#popupcontent > a:nth-child(6) > center:nth-child(2) > input:nth-child(1)').click()
	
	# BigBag_ClaI_enzyme = ClaI_enzyme(DNAsequence)
	# BigBag_BamHI_enzyme = BamHI_enzyme(DNAsequence)

	# BigBag_EcoRI_enzyme = EcoRI_enzyme(DNAsequence)
	# BigBag_HindIII_enzyme = HindIII_enzyme(DNAsequence)
	# BigBag_PstI_enzyme = PstI_enzyme(DNAsequence)

	ClaI_BamHI = []
	BamHI_ClaI = []
	# apply BamHI enzyme on bag As
	for j in range(0, len(As)):
		newSeq = BamHI_enzyme(As[j])
		seq = newSeq[0]
		for i in range(1,len(newSeq)):
			seq = seq + " " + newSeq[i]
		# Left side
		browser.find_element_by_css_selector('#left > li:nth-child(' + str(j+1)+ ') > input:nth-child(1)').send_keys(seq)
		time.sleep(1)
		selector = 'body>a:nth-child(3)>form:nth-child(1)>center:nth-child(1)>aside:nth-child(2)>input:nth-child(3)'
		browser.find_element_by_css_selector(selector).click()
		print str(j+1) + " -> " + seq
		ClaI_BamHI.append(seq)
	time.sleep(2)
	selector = 'body > a:nth-child(3) > form:nth-child(1) > center:nth-child(1) > aside:nth-child(2) > input:nth-child(4)'
	browser.find_element_by_css_selector(selector).click()

	# Apply ClaI enzyme on bag Bs
	print 
	for j in range(0, len(Bs)):
		newSeq = ClaI_enzyme(Bs[j])
		seq = newSeq[0]
		for i in range(1,len(newSeq)):
			seq = seq + " " + newSeq[i]
		# Right side
		browser.find_element_by_css_selector('#right > li:nth-child(' + str(j+1)+ ') > input:nth-child(1)').send_keys(seq)
		time.sleep(1)
		selector = 'body>a:nth-child(3)>form:nth-child(1)>center:nth-child(1)>aside:nth-child(3)>input:nth-child(3)'
		browser.find_element_by_css_selector(selector).click()
		print str(j+1) + " -> " + seq
		BamHI_ClaI.append(seq)
	time.sleep(2)
	selector = 'body > a:nth-child(3) > form:nth-child(1) > center:nth-child(1) > aside:nth-child(3) > input:nth-child(4)'
	browser.find_element_by_css_selector(selector).click()

	# print BagMaker(ClaI_BamHI,'A')
	# print BagMaker(BamHI_ClaI,'B')
	time.sleep(15)
	browser.find_element_by_css_selector('#btn-style').click()
	time.sleep(25)
	browser.quit()


if __name__ == "__main__": main()
